package client;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Hashtable;

import net.AppSocket;
import net.ByteOp;
import net.ConnectionInfo;
import net.TimeoutLimitException;

public class ChatThread extends Thread{
	private Client client;
	private AppSocket sock;
	private ConnectionInfo destino;
	private boolean vive;
	private ClientGuiListener listener;
	private ChatListener chatListener;
	public ChatThread(ChatListener chatListener, Client client, AppSocket sock, ConnectionInfo destino){
		this.client = client;
		this.chatListener = chatListener;
		this.sock = sock;
		this.destino = destino;
		this.vive = true;
		this.start();
		
	}
	public void kill(){
		this.vive = false;
		client.getTabelaDeSockets().remove(destino.getIp());
		client.getListaDeThreads().remove(destino.getIp());
		sock.kill();
	}
	public void addListener(ClientGuiListener listener){
		this.listener = listener;
	}

	private Object getObjFromBytes(byte[] array, int offset) throws IOException, ClassNotFoundException{
		ByteArrayInputStream bais = new ByteArrayInputStream(array, offset, array.length-offset);
		ObjectInputStream ois = new ObjectInputStream(bais);
		Object retorno = ois.readObject();
		
		return retorno;
	}
	@SuppressWarnings("unchecked")
	@Override
	public void run(){
		while(vive){
			byte[] data = sock.receive();
			if(data != null){
				if (data.length > 0) {
					switch (data[0]) {
					case 0: // Mensgem de texto recebida
						String msg = "";
						byte[] rawMsg = new byte[ByteOp
								.byteArrayToInt(new byte[] { data[2], data[3],
										data[4], data[5] })];
						System.out.println("THREAD RECEBEU MENSAGEM!!! ");
						for (int i = 0; i < rawMsg.length; i++) {
							rawMsg[i] = data[6 + i];

						}
						try {
							msg = new String(rawMsg, "UTF-16");
						} catch (UnsupportedEncodingException e) {

						}
//						if (listener != null) {
//							listener.msgRecieved(msg, destino, this);
//						}
						chatListener.msgRecieved(msg, destino, data[1]);
						break;
					case 1: // Requisio de chat de voz recebida
						System.out.println("RECEBEU CONVITE PARA CHAT DE VOZ");
						chatListener.callRecieved(destino);	
						break;
					case 2: // Requisio para transmitir arquivo

						break;
					case 3: // Requisio para "terminar" a conversa

						break;
					case 4: // Recebe requisio de id
						System.out.println("CHAT THREAD RECEBEU REQUISIO DE ID");
						byte retorno = this.chatListener.idRequestReceived(this.destino, data[1]);
						byte[] pacote = {5, retorno};
						try {
							sock.send(pacote);
						} catch (TimeoutLimitException e) {
							e.printStackTrace();
						}
						break;
					case 5: // Recebe id da requisio
						System.out.println("CHAT THREAD RECEBEU ID");
						client.putId(data[1]);
						break;
					case 6:
						System.out.println("RECEBEU CONVITE PARA CHAT MAROTO");
						byte idDoCapeta = data[1];
						try {
							ArrayList<ChatId> participantes = (ArrayList<ChatId>) this.getObjFromBytes(data, 2);
							chatListener.conviteDeConversaRecebido(participantes, idDoCapeta, this.destino);
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (ClassNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					
						
						break;
					case 7:
						System.out.println("FUI NOTIFICADO PELO NOVO PARTICIPANTE");
						chatListener.novoParticipante(destino, data[2], data[1]);
						break;
					case 8://RESPOSTA PARA CONVERSA DE VOZ
						System.out.println("RECEBEU RESPOSTA DA CONVERSA DE VOZ");
						client.putRespostaVoz(data[1]);
						break;
					case -33:

						break;
					}
				}
			}else{
				this.kill();
			}
			
		}
		System.out.println("CHAT THREAD MORREU");
	}

}
